#!/usr/local/bin/perl
#
# ice-form.pl -- cgi compliant ICE search interface // May 21 1994
#
# (C) Christian Neuss, Fraunhofer IGD (neuss@igd.fhg.de) 

#--- start of configuration --- put your changes here ---
# Title or name of your server:
#   Example: local($title)="ICE Indexing Gateway";
local($title)="ICE Indexing Gateway";

# location of "ice.pl"
#   Example: require "/igd/a3/home1/neuss/Perl/ice.pl";
require "/igd/a3/home1/neuss/Perl/ice.pl";

# URL path of this script "ice.pl"
#   Example: 
local($scriptname)="/htbin/ice-form.pl";
#--- end of configuration --- don't change anything below ---

sub send_index {
    print "Content-type: text/html\n\n";
    print "<HEAD>\n<TITLE>", $title;
    print "</TITLE>\n</HEAD>\n";
    print "<H1>$title</H1>\n";

    print "This is a gateway to the ICE indexing software.\n";
    print "By supplying keywords and setting special options, you can\n";
    print "do a free text search on this World Wide Web archive.<P>\n";

    print "<FORM ACTION=\"$scriptname\">\n";
    print "<HR>\n";
    print "Type in the keyword, or provide several keywords\n";
    print "connected with \"and\" and \"or\". <BR>\n";
    print "Example: \"picture and binary\"\n";
    print "<INPUT NAME=\"KEYWORDS\" VALUE=\"test\" SIZE=60><BR>\n";
    print "<HR>\n";
  
    print "Turn on use of thesaurus to extend a search to\n";
    print "all synonyms of a term, turn on fault tolerant searches\n";
    print "to extend searches to words which are \"similar\" to the\n";
    print "given term:<BR> <inPUT TYPE=\"checkbox\"\n";
    print "NAME=\"THESAURUS\" VALUE=\"thesaurus\">   Use Thesaurus\n";
    print "<inPUT TYPE=\"checkbox\" NAME=\"LEVENSHTEIN\"\n";
    print "VALUE=\"levenshtein\"> Fault tolerant search\n";
    print "<HR>\n";

    print "You can provide an optional context which limits \n";
    print "searches to certain subtrees of the document hierarchy.<BR>\n";

    print "<INPUT NAME=\"CONTEXT\" VALUE=\"\" SIZE=60> <BR>\n";
    print "Start search: <INPUT TYPE=\"submit\" VALUE=\" Ok \">\n";
    print "<HR>\n";

    print "Reset default values: <inPUT TYPE=\"reset\" \n";
    print "VALUE=\"Reset\"> </FORM>\n";
    print "</BODY>\n";
}

sub doit {
    do { &'send_index; return; } unless (length($ENV{"QUERY_STRING"})>0);
    local(@query_strings) = split("&", $ENV{"QUERY_STRING"});
    foreach $q (@query_strings) {
      ($attr, $val) = split("=", $q);
      # this is still just a hack..
      $val =~ s/%22/"/g;
      $val =~ s/%27/"/g;
      $val =~ s/%3F/?/g;
      $val =~ s/%26/&/g;
      $val =~ s/%3D/=/g;
      $val =~ s/%5B/[/g;
      $val =~ s/%5D/]/g;
      $val =~ s/%7B/{/g;
      $val =~ s/%7D/}/g;
      $val =~ s/%5C/\\/g;
      $val =~ s/%2F/\//g;
      $val =~ s/\+/ /g;
      $val =~ s/^\s//;
      $queryvals{$attr} = $val;
    }

    $pquery = $query = $queryvals{KEYWORDS};
    $context = $queryvals{CONTEXT};
    $thesaurus = $queryvals{THESAURUS};
    $levenshtein = $queryvals{LEVENSHTEIN};
    if(length($thesaurus)>0){
      $pquery.=" -T";
    }
    if(length($levenshtein)>0){
      $pquery.=" -L";
    }
    if(length($context)>0){
      $pquery.=" @ $queryvals{CONTEXT}";
    }

    print "Content-type: text/html\n\n";

    print "<HEAD>\n<TITLE>Search of $title\n";
    print "</TITLE>\n</HEAD>\n";
    print "<BODY>\n<H1>", $title, "</H1>\n";

 ###print "query $pquery\n";
    ($err,$page) = &getquery($pquery);
    if($err){
      print "Query was: $query<BR>\n";
      print "Problem: $err\n";
      print "</BODY>";
      return undef;
    }
    print "Preferences set for this query:\n";
    print "<UL>\n";
    print "<LI> query was \"$query\"\n";
    if($context){
      print "<LI> context was set to $context.\n";
    }
    if($thesaurus){
      print "<LI> use of thesaurus turned on\n";
    }
    if($levenshtein){
      print "<LI> fault tolerant searching turned on\n";
    }
    print "</UL>\n";
    if($page){
     print "<P>The index contains the following\n";
     print "items relevant to \`$query\':<P>\n";
     print "$page\n";
    }else{
     print "<P> Nothing found.\n";
    }      
 
    print "</BODY>\n";
}

&doit();