#!/usr/local/bin/perl
# ice-idx.pl - create an index file // May 21 1994
# 
# (C) Christian Neuss, Fraunhofer IGD (neuss@igd.fhg.de) 

# Have this script called up on a regular base via 'cron'.
# Make sure that, for security reasons, it is being executed
# with a user id other then root, and that this user has
# both read access to the html files and write access to
# the index file.
# Here's an example of a crontab entry:
# 1 20 * * *  neuss /usr/httpd/ice-idx.pl >/dev/console 2>&1

#--- start of configuration --- put your changes here ---
# The directory/directories to scan for html-files.
# It's better to supply a tailing "/" for each directory,
# since otherwise automounting may not work.
# Example:
#  SEARCHDIRS="/usr/www/dir/ /tmp/html/ /usr/foo/html-dir/" 
$SEARCHDIRS="/igd/a3/home1/gerfi/icib/ /igd/a3/home/stud/glaser/mms/";

# Name of the index file.
# Example:
#  $INDEXFILE="/usr/local/httpd/index.idx"
$INDEXFILE="/usr/local/etc/httpd/index/index.idx";
##$INDEXFILE="/tmp/index.idx";

#--- end of configuration --- don't change anything below ---


open(FILES,"find $SEARCHDIRS -type f -name '*.html' -print |");
open(INDEX,">$INDEXFILE");

while(<FILES>){
  local($file)=$_;
  do &indexfile($file);
}
close(FILES);

sub indexfile{
  local($file)=@_;
  local(%freqlist,$title,$intitle);
  open(fpin,"$file"); #err
  while(<fpin>){
    s/([^\n])</\1\n</g; # add CR before every '<'
    s/>([^\n])/>\n\1/g; # add CR after every '>'
    s/<([^>]*)\n/<\1/g;
    #if($line++>40) {exit;}
    foreach (split(/\n/,$_)){
       if(m:<title>:i){
        $intitle="y";
        $title="";
      }
      if(m:</title>:i){
        $intitle="";
      }
      # if outside a tag
      if(!/</){
        # dispose of unwanted chars
        tr/A-Za-z&;0-9/ /cs;
        if ($intitle){
          $title.="$_";
        } else {
          # dispose of unwanted chars
          tr/A-Za-z&;/ /cs;
          foreach (split(/ /,$_)){
            next unless ($_); # if empty skip
            if(/^[A-Z][^A-Z]*$/){  # "If" to "if"
              tr/A-Z/a-z/;
            }
            $freqlist{$_}++;
          }
        }
      }
    }
  }
  $file =~ tr/\n/ /s;
  $title =~ tr/\n/ /s;
  print INDEX "@f $file\n";
  print INDEX "@t $title\n";
  foreach $w (sort keys(%freqlist)){
    print INDEX "$freqlist{$w} $w\n";
  }
  %freqlist=();
  close(fpin);
}