#!/usr/local/bin/perl
#
# ice.pl -- ICE search basic routines // May 21 1994
#
# (C) Christian Neuss, Fraunhofer IGD (neuss@igd.fhg.de) 

#--- start of configuration --- put your changes here ---
# Location of the indexfile:
#   Example: $indexfile="/usr/local/etc/httpd/index/index.idx";
$indexfile="/usr/local/etc/httpd/index/index.idx";
###   $indexfile="/igd/a3/home1/neuss/Perl/newindex.idx";

# Location of the "egrep (1)" command:
#   Example: $grepcmd="/usr/bin/egrep";
$grepcmd="/usr/bin/egrep";

# Location of the thesaurus data file:
#   Example: $thesfile="/igd/a3/home1/neuss/Perl/thes.dat";
$thesfile="/igd/a3/home1/neuss/Perl/thes.dat";

# URL Mappings (a.k.a Aliases) that your server does
# map "/" to some path to reflect a "document root"
#   Example
#   %urltopath = (
#   '/mms',   '/usr/stud/glaser/mms', 
#   '/',      '/usr/www',
#   );
%urltopath = (
  '/icib',  '/igd/a3/home1/gerfi/icib',
  '/mms',   '/igd/a3/home/stud/glaser/mms',
  '/',      '/tmp',
);
#--- end of configuration --- don't change anything below ---


#$orig="pic[rut]*e or {foobar} or image -L -T @ /icib";
#$orig="fridelzupf or test @ /";
#$foo=&getquery($orig);
#print $foo;
#exit;

sub getquery{
  local($query)=@_;
  local($pager)="<UL>\n";
  local($hitcount)="<UL>";
  local($err,$context,$thes,$leven,$bool,@ret)=&parsequery($query);
  if($err){
    return $err; #XXX hm..
  }

  local(@tmplist)= &getindex($thes,$bool,@querystring);
  
  if($context){
    # translate virtual<->physical path
    local($v,$p)=($context,&translate($context));
    @tmplist=grep(/^[^\n]*\n$p/,@tmplist);
    ###print "translate context from \n$v to \n$p\n";
  }
  
  for $w (@tmplist){
    local($freq,$file,$title,@hits)=split(/\n/,$w);
    local($virt)=&translateback($file);
    ###print "translate docpath from \n$file to \n$virt\n";
    $w=join("\n",$freq,$virt,$title,@hits);
  }
  
  sub downbynumber {$b <=> $a;}
  @tmplist = sort downbynumber @tmplist;
  
  foreach $w (@tmplist){
    local($freq,$file,$title,@hits)=split(/\n/,$w);
    $hitcount++;
    ###print "$freq,$title\n";    
    $pager .= "<LI> <A HREF=\"$file\"><I>$title</I></A><BR>\n";
    $pager .= "$file<BR>\n";
    foreach $line (@hits){
      $pager .= "$line<BR>\n";
    }
  }
  if($hitcount>0){
    $pager .= "</UL>";
  }else{
    $pager = "";
  }
  ("",$pager); # return;
}

# parse query
sub parsequery{
  local($query)=@_;
  local($context,$thesaurus,$levenshtein);
  $_=$query;
  # "optional URL context as @-sign"
  if(m:^([^@]*)\s+@\s*(.*)$:){
    $context=$2;
    $_=$1;
  } ### to be added: "IN"
  while(m:\s+-[LT]$:){
    # "turn on levenshtein by adding -L"
    if(m:^(.*)\s+-T$:){
      $thesaurus="y";
      # print "turn on thesaurus\n";
      $_=$1;
    } 
    # "turn on "global" thesaurus" by adding -T"
    if(m:^(.*)\s+-L$:){
      $levenshtein="y";
      # print "turn on levenshtein\n";
      $_=$1;
    }
  } 
  # print "remaining query $_\n";
  @list=split(/ /,$_);
  $expectword="y";
  foreach $w (@list){
    $_ = $w;
    tr/A-Z/a-z/;
    if(/^and$/) {
      if($expectword) {$err="$w"; last;}
      $expectword="y";
      $bool .= "&";
    }elsif(/^or$/){
      if($expectword) {$err="$w"; last;}
      $expectword="y";
      $bool .= "+";
    }else{
       unless($expectword) {$err="$w"; last;}
      $expectword="";
       push(@querystring,$w); 
    }
  }
  if($expectword){
    return ("syntax error in query: must end with keyword!");
  }
  if($err){
    return ("syntax error in query near '$err'!");
  }
  return("",$context,$thesaurus,$levenshtein,$bool,@querystring);
}

# get index entries matching query
sub getindex{
  local($thes,$bool,@query)=@_;
  local(@list,$count,$item,$w,@wordnum,$grepexpr,$ret);

  foreach $item (@query){
    ++$count;
    local($w);
    $_=$item;
    local($flag)=$thes;
    if (/{(.*)}/) {
      $_ = $1;
      $flag="y";
    }
    # convert e.g. "Picture" to "picture"
    if(/^[A-Z][^A-Z]*$/){
      tr/A-Z/a-z/;
    }
    # evaluate thesaurus
    if ($flag) {
      push (@keywords,$_);
      $wordnum{$_}=$count;
      local(@synonyms)=split(/\n/,&thesread($thesfile,$_));
      foreach $w (@synonyms){
        push (@keywords,$w);
        $wordnum{$w}=$count;
      }
    } else {
      $w=$_;
      push (@keywords,$w);
      $wordnum{$w}=$count;  
    }
  }

  $grepexpr="^@";
  foreach (@keywords) { $grepexpr.="|$_"; }

  # egrep is a lot faster then anything we could do in Perl..
  ###print "grepexpr is $grepexpr\n";
  open(fpin,"$grepcmd '$grepexpr' < $indexfile |");
  while(<fpin>){
    if(!/^@/){
      foreach $w (@keywords){
         if(/(\d+)\s+($w)$/){
          $freq=$1; 
          $word=$2;
          if(length($word)>0){
            $token=$wordnum{$w};
            $entry=join("\n",$path,$token,$word,$freq,$title);
            push(@list,$entry);
          }
        }
      }
    } else {
      if(/@f\s(.*)$/) { $path  =$1; next; }
      if(/@t\s(.*)$/) { $title =$1; next; }
    }
  }

  ### print "list has $#list elements\n";
  @list=sort(@list);
  &evaluateexpr($bool,@list); #return
}

sub evaluateexpr {
  local($bool,@list)=@_;
  local($lastpath,$lasttitle,$retval);
  local($relevance,%wordlist);
  local(@reslist);
  
  # let's do some initialisation
  ($path,$token,$word,$freq,$title)=split(/\n/,$list[0]);
  $lastpath=$path;
  $lasttitle=$title;
  $relevance=$freq;
  %wordlist=();
  local($fw);
  if($word ne $query[$token-1]){
    $fw="$freq ($query[$token-1])";
  }else{
    $fw="$freq";
  }
  $wordlist{$word}=$fw;
  foreach $i (0 .. $count-1){
    $exprarray[$i]=0;
  }
  
  # loop over all entries in list
  foreach $i (0 .. $#list+1){ # sic!
    if($i <= $#list){
      ($path,$token,$word,$freq,$title)=split(/\n/,$list[$i]);
    } 
    # if path has changed -> compute expression
    if(($lastpath ne $path) || ($i==$#list+1)) {
      $expr=join('',@exprarray);
      ###print "path changed, call $exprarray ($expr) and ($bool)\n";
      local($ret)=&booleval($bool,$expr);
      if($ret==1){
        local($w);
        $retval .= "$relevance\n"; #here's a hit
        $retval .= "$lastpath\n"; # here's a hit
        $retval .= "$lasttitle\n"; # here's a hit
        foreach $w (sort keys(%wordlist)){
          $retval .= "\"$w\" $wordlist{$w}\n";
        }
        push(@reslist,$retval);
        $retval="";
      }
      if($i==$#list+1){
        last; # leave loop
      }
      $lastpath=$path;
      $lasttitle=$title;
      $relevance=$freq;
      %wordlist=();
      if($word ne $query[$token-1]){
        $fw="$freq ($query[$token-1])";
      }else{
        $fw="$freq";
      }
      $wordlist{$word}=$fw;
      foreach $i (0 .. $count-1){
        $exprarray[$i]=0;
      }
      $exprarray[$token-1]=1;
    }else{
      $exprarray[$token-1]=1;
      $relevance += $freq;
      if($word ne $query[$token-1]){
        $fw="$freq ($query[$token-1])";
      }else{
        $fw="$freq";
      }
      $wordlist{$word}=$fw;
    }
  }
  @reslist; # return;
}

# compute boolean expressions
# e.g. to compute "1 or 0 and 1" use booleval("101","+&")
sub booleval {
  local($arg1,$arg2)=@_;
  local($t1,$t2,$i,$op,$opers,$terms);

  @opers=split(//,$arg1);
  @terms=split(//,$arg2);

  #test output:  
  #local(@fump)=();
  #for $i (0..($#terms-1)){
  #  push(@fump,$terms[$i]);
  #  push(@fump,$opers[$i]);
  #}
  #push(@fump,$terms[$#terms]);
  #print "calling booleval @fump -> "; 
  
  $t1=$terms[0];
  if($#terms==0){ # only one term given
    return $t1;
  }
  for $i (0..($#terms-1)){
    $t2=$terms[$i+1];
    $op=$opers[$i];
    if($op eq "+"){
      if($t1!=0){ 
        return 1;
      } else {
        $t1=$t2;
      }
    }else{
      $t1*=$t2;
    }
  }
  return $t1;
}

# evaulate a thesaurus file for a given term
sub thesread {
  local($thesfile,$word)=@_;
  local($last,$result,$line)="";
  local($allowed)="EQ|AB|UF";
  unless (open(fpin,$thesfile)) {
    print STDERR "Cannot open thesaurus file $thesfile\n";
    return undef;
  }
  while(<fpin>){
    $line++;
    if (m:^(\S+)\s+$:) {
      $last=$1;
    }elsif((m:^\s+($allowed)\s+(\S+)$:)&&($last eq $word)) {
      $result .= "$2\n";
    }
  }
  close(fpin);
  $result;
}

# translate URL to physical
sub translate {
  local($url)=@_;
  local($docroot,$aliasdone);
  $_=$url;
  s/(.*)\/$/\1/; # strip off a trailing "/"
  #print "Was $_\n";
  foreach $key (keys(%urltopath)){
    if( ($key ne "/") && (/^$key/) ){
      s/^$key/$urltopath{$key}/;
      #print "replacing $key with $urltopath{$key}\n";
    }
  }
  #print "Now is $_\n";
  $_;
}

# translate physical to URL
sub translateback {
  local($url)=@_;
  local($docroot,$aliasdone);
  $_=$url;
  s/(.*)\/$/\1/; # strip off a trailing "/"
  #print "Was $_\n";
  foreach $key (keys(%urltopath)){
    if($key eq "/"){
      $docroot=$urltopath{$key};
    }else{ 
      if(/^$urltopath{$key}/){
        s/^$urltopath{$key}/$key/;
        $aliasdone="y";
        #print "replacing $urltopath{$key} with $key\n";
      }
    }
  }
  if(!$aliasdone && $docroot){
    s/$docroot//;
  }
  #print "Now is $_\n";
  $_;
}